'****************************************************************
'*  Name    : LCD_P+.inc                                       *
'*  Author  : John Barrat                                       *
'*  Notice  : Copyright (c) 2004 John Barrat                    *
'*          : All Rights Reserved                               *
'*  Date    : 10/11/2004                                        *
'*  Version : 1.0                                               *
'*  Notes   : Generalised subroutines for setting up controlling*
'*          : and Printing messages on an Alphanumeric LCD      *
'****************************************************************


' Uses the following Variables as External Parameters:
#IFDEF SPCV3
Dim LCD_Contrast As Byte
#ENDIF
' Uses following internally
Dim LCD_IntB As Byte
Dim LCD_IntA As Byte

' Add the  following to the user.mcd file
'KEY ("CLL")
'   DeviceCore = [dc14, dc16]
'   Highlighter = Keyword 
'   Hint = "<b>CLL</b> <i>{Line Number},{from Char Number}</i>
'ENDKEY

' CLL Command - With no parameters, same as CLS
'               With 1 param, clears line specified in Param
'               With 2 params. clears to end of line P1 from position P2

GoTo SkipLCD_INC

CLL MACRO P1, P2  ' Syntax CLL Line, Position 
#IF (PRM_COUNT > 2) 
    #ERROR "Too many parameters in CLL macro call"
#ELSE
    #IF (PRM_COUNT == 0)
        Cls
    #ELSE
        #IF (PRM_COUNT == 1)
            #IF (PRM_1 == NUM8)
                NUM_BYTE P1, LCD_IntB
                LCD_IntA = 1
                GoSub LCD_CLL
            #ELSE
                #ERROR "CLL - Parameter must be 8 bit"
            #ENDIF
        #ELSE
            #IF (PRM_1 == NUM8) && (PRM_2 == NUM8)
                NUM_BYTE P1, LCD_IntB
                NUM_BYTE P2, LCD_IntA
                GoSub LCD_CLL
            #ELSE
                #ERROR "CLL - Both Parameters must be 8 bits"
            #ENDIF     
        #ENDIF
    #ENDIF
#ENDIF
ENDM

LCD_CLL:
    Print At LCD_IntB, LCD_IntA, Rep " "\LCD_NoChars - LCD_IntA + 1
    Cursor LCD_IntB, LCD_IntA
Return

'KEY ("CSRL")
'	DeviceCore = [dc12], [dc14], [dc16]
'	Highlighter = KeywordUser
'	Hint = "<b>CSRL</b> <i></i>"
'ENDKEY

CSRL MACRO 
    GoTo CSR_Left
ENDM

CSRR MACRO 
    GoTo CSR_Right
ENDM

CSR_Left:
	LCD_IntB = $10
    GoTo LCDSendCmd
CSR_Right:
    LCD_IntB = $14
' Sends command to LCD and resets the CSRPos offset to 0
LCDSendCmd:
   Print $FE, LCD_IntB
Return


LCD_Adjust_Contrast:
    HPWM 1,LCD_Contrast,1221                ' Set the HPWM to adjust contrast using LCD_Contrast
Return


SkipLCD_INC:
